#include "x_err.hpp"
#include "x_alloc.hpp"

void *smalloc(size_t size) {
  void *res = malloc(size);
  if (!res) fatalError("memory allocation failed");
  return res;
}

void _sfree(void *&block) {
  if (block == NULL) fatalError("attempt to deallocate via NULL pointer");
  free(block);
  block = NULL;
}

void __far *sfmalloc(size_t size) {
  void __far *res = _fmalloc(size);
  if (!res) fatalError("memory allocation failed");
  return res;
}

void _sffree(void __far *&block) {
  if (block == NULL) fatalError("attempt to deallocate via NULL pointer");
  _ffree(block);
  block = NULL;
}
